<?php
if ( ! class_exists( 'Hardware_Dealer_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Hardware_Dealer_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Hardware_Dealer_Plugin_Activation_WPElemento_Importer {

        private static $hardware_dealer_instance;
        public $hardware_dealer_action_count;
        public $hardware_dealer_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$hardware_dealer_instance) ) {
            self::$hardware_dealer_instance = new self();
          }
          return self::$hardware_dealer_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'hardware_dealer_recommended_plugins', array($this, 'hardware_dealer_recommended_elemento_importer_plugins_array') );

            $hardware_dealer_actions                   = $this->hardware_dealer_get_recommended_actions();
            $this->hardware_dealer_action_count        = $hardware_dealer_actions['count'];
            $this->hardware_dealer_recommended_actions = $hardware_dealer_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function hardware_dealer_recommended_elemento_importer_plugins_array($hardware_dealer_plugins){
            $hardware_dealer_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'hardware-dealer'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'hardware-dealer'),               
            );
            return $hardware_dealer_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'hardware-dealer-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('hardware-dealer-plugin-activation-script', 'hardware_dealer_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'hardware-dealer'),
                    'activating' => esc_html__('Activating', 'hardware-dealer'),
                    'error' => esc_html__('Error', 'hardware-dealer'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'hardware-dealer-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function hardware_dealer_get_recommended_actions() {

            $hardware_dealer_act_count  = 0;
            $hardware_dealer_actions_todo = get_option( 'recommending_actions', array());

            $hardware_dealer_plugins = $this->hardware_dealer_get_recommended_plugins();

            if ($hardware_dealer_plugins) {
                foreach ($hardware_dealer_plugins as $hardware_dealer_key => $hardware_dealer_plugin) {
                    $hardware_dealer_action = array();
                    if (!isset($hardware_dealer_plugin['slug'])) {
                        continue;
                    }

                    $hardware_dealer_action['id']   = 'install_' . $hardware_dealer_plugin['slug'];
                    $hardware_dealer_action['desc'] = '';
                    if (isset($hardware_dealer_plugin['desc'])) {
                        $hardware_dealer_action['desc'] = $hardware_dealer_plugin['desc'];
                    }

                    $hardware_dealer_action['name'] = '';
                    if (isset($hardware_dealer_plugin['name'])) {
                        $hardware_dealer_action['title'] = $hardware_dealer_plugin['name'];
                    }

                    $hardware_dealer_link_and_is_done  = $this->hardware_dealer_get_plugin_buttion($hardware_dealer_plugin['slug'], $hardware_dealer_plugin['name'], $hardware_dealer_plugin['function']);
                    $hardware_dealer_action['link']    = $hardware_dealer_link_and_is_done['button'];
                    $hardware_dealer_action['is_done'] = $hardware_dealer_link_and_is_done['done'];
                    if (!$hardware_dealer_action['is_done'] && (!isset($hardware_dealer_actions_todo[$hardware_dealer_action['id']]) || !$hardware_dealer_actions_todo[$hardware_dealer_action['id']])) {
                        $hardware_dealer_act_count++;
                    }
                    $hardware_dealer_recommended_actions[] = $hardware_dealer_action;
                    $hardware_dealer_actions_todo[]        = array('id' => $hardware_dealer_action['id'], 'watch' => true);
                }
                return array('count' => $hardware_dealer_act_count, 'actions' => $hardware_dealer_recommended_actions);
            }

        }

        public function hardware_dealer_get_recommended_plugins() {

            $hardware_dealer_plugins = apply_filters('hardware_dealer_recommended_plugins', array());
            return $hardware_dealer_plugins;
        }

        public function hardware_dealer_get_plugin_buttion($slug, $name, $function) {
                $hardware_dealer_is_done      = false;
                $hardware_dealer_button_html  = '';
                $hardware_dealer_is_installed = $this->is_plugin_installed($slug);
                $hardware_dealer_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $hardware_dealer_is_activeted = (class_exists($function)) ? true : false;
                if (!$hardware_dealer_is_installed) {
                    $hardware_dealer_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $hardware_dealer_plugin_install_url = wp_nonce_url($hardware_dealer_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $hardware_dealer_button_html        = sprintf('<a class="hardware-dealer-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($hardware_dealer_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'hardware-dealer'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'hardware-dealer')
                    );
                } elseif ($hardware_dealer_is_installed && !$hardware_dealer_is_activeted) {

                    $hardware_dealer_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($hardware_dealer_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $hardware_dealer_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $hardware_dealer_button_html = sprintf('<a class="hardware-dealer-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($hardware_dealer_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'hardware-dealer'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'hardware-dealer')
                    );
                } elseif ($hardware_dealer_is_activeted) {
                    $hardware_dealer_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'hardware-dealer'));
                    $hardware_dealer_is_done     = true;
                }

                return array('done' => $hardware_dealer_is_done, 'button' => $hardware_dealer_button_html);
            }
        public function is_plugin_installed($slug) {
            $hardware_dealer_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $hardware_dealer_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($hardware_dealer_installed_plugins[$hardware_dealer_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $hardware_dealer_keys = array_keys($this->get_installed_plugins());
            foreach ($hardware_dealer_keys as $hardware_dealer_key) {
                if (preg_match('|^' . $slug . '/|', $hardware_dealer_key)) {
                    return $hardware_dealer_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Hardware_Dealer_Plugin_Activation_WPElemento_Importer::get_instance();